// A Bison parser, made by GNU Bison 3.7.2.

// Skeleton interface for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2020 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.


/**
 ** \file /home/hobborg/FAMAF/Doctorado/fig/git/src/ModelParser.hpp
 ** Define the ModelParserGen::parser class.
 */

// C++ LALR(1) parser skeleton written by Akim Demaille.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.

#ifndef YY_YY_HOME_HOBBORG_FAMAF_DOCTORADO_FIG_GIT_SRC_MODELPARSER_HPP_INCLUDED
# define YY_YY_HOME_HOBBORG_FAMAF_DOCTORADO_FIG_GIT_SRC_MODELPARSER_HPP_INCLUDED
// "%code requires" blocks.
#line 21 "/home/hobborg/FAMAF/Doctorado/fig/git/src/ModelParserGen.yy"

#include <cassert>
#include <string>
#include <sstream>
#include <memory>
    
#include "ModelAST.h"
#include "Util.h"

    using std::shared_ptr;
    using std::make_shared;
    using std::static_pointer_cast;
    
//definition YY_DECL should be available also for ModelScannerGen.ll
//ModelScannerGen includes ModuleParser.hpp
# define YY_DECL							\
    ModelParserGen::ModelParser::symbol_type yylex (shared_ptr<ModelAST> *result)

#line 68 "/home/hobborg/FAMAF/Doctorado/fig/git/src/ModelParser.hpp"

# include <cassert>
# include <cstdlib> // std::abort
# include <iostream>
# include <stdexcept>
# include <string>
# include <vector>

#if defined __cplusplus
# define YY_CPLUSPLUS __cplusplus
#else
# define YY_CPLUSPLUS 199711L
#endif

// Support move semantics when possible.
#if 201103L <= YY_CPLUSPLUS
# define YY_MOVE           std::move
# define YY_MOVE_OR_COPY   move
# define YY_MOVE_REF(Type) Type&&
# define YY_RVREF(Type)    Type&&
# define YY_COPY(Type)     Type
#else
# define YY_MOVE
# define YY_MOVE_OR_COPY   copy
# define YY_MOVE_REF(Type) Type&
# define YY_RVREF(Type)    const Type&
# define YY_COPY(Type)     const Type&
#endif

// Support noexcept when possible.
#if 201103L <= YY_CPLUSPLUS
# define YY_NOEXCEPT noexcept
# define YY_NOTHROW
#else
# define YY_NOEXCEPT
# define YY_NOTHROW throw ()
#endif

// Support constexpr when possible.
#if 201703 <= YY_CPLUSPLUS
# define YY_CONSTEXPR constexpr
#else
# define YY_CONSTEXPR
#endif
# include "location.hh"
#include <typeinfo>
#ifndef YY_ASSERT
# include <cassert>
# define YY_ASSERT assert
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

#line 10 "/home/hobborg/FAMAF/Doctorado/fig/git/src/ModelParserGen.yy"
namespace ModelParserGen {
#line 203 "/home/hobborg/FAMAF/Doctorado/fig/git/src/ModelParser.hpp"




  /// A Bison parser.
  class ModelParser
  {
  public:
#ifndef YYSTYPE
  /// A buffer to store and retrieve objects.
  ///
  /// Sort of a variant, but does not keep track of the nature
  /// of the stored data, since that knowledge is available
  /// via the current parser state.
  class semantic_type
  {
  public:
    /// Type of *this.
    typedef semantic_type self_type;

    /// Empty construction.
    semantic_type () YY_NOEXCEPT
      : yybuffer_ ()
      , yytypeid_ (YY_NULLPTR)
    {}

    /// Construct and fill.
    template <typename T>
    semantic_type (YY_RVREF (T) t)
      : yytypeid_ (&typeid (T))
    {
      YY_ASSERT (sizeof (T) <= size);
      new (yyas_<T> ()) T (YY_MOVE (t));
    }

#if 201103L <= YY_CPLUSPLUS
    /// Non copyable.
    semantic_type (const self_type&) = delete;
    /// Non copyable.
    self_type& operator= (const self_type&) = delete;
#endif

    /// Destruction, allowed only if empty.
    ~semantic_type () YY_NOEXCEPT
    {
      YY_ASSERT (!yytypeid_);
    }

# if 201103L <= YY_CPLUSPLUS
    /// Instantiate a \a T in here from \a t.
    template <typename T, typename... U>
    T&
    emplace (U&&... u)
    {
      YY_ASSERT (!yytypeid_);
      YY_ASSERT (sizeof (T) <= size);
      yytypeid_ = & typeid (T);
      return *new (yyas_<T> ()) T (std::forward <U>(u)...);
    }
# else
    /// Instantiate an empty \a T in here.
    template <typename T>
    T&
    emplace ()
    {
      YY_ASSERT (!yytypeid_);
      YY_ASSERT (sizeof (T) <= size);
      yytypeid_ = & typeid (T);
      return *new (yyas_<T> ()) T ();
    }

    /// Instantiate a \a T in here from \a t.
    template <typename T>
    T&
    emplace (const T& t)
    {
      YY_ASSERT (!yytypeid_);
      YY_ASSERT (sizeof (T) <= size);
      yytypeid_ = & typeid (T);
      return *new (yyas_<T> ()) T (t);
    }
# endif

    /// Instantiate an empty \a T in here.
    /// Obsolete, use emplace.
    template <typename T>
    T&
    build ()
    {
      return emplace<T> ();
    }

    /// Instantiate a \a T in here from \a t.
    /// Obsolete, use emplace.
    template <typename T>
    T&
    build (const T& t)
    {
      return emplace<T> (t);
    }

    /// Accessor to a built \a T.
    template <typename T>
    T&
    as () YY_NOEXCEPT
    {
      YY_ASSERT (yytypeid_);
      YY_ASSERT (*yytypeid_ == typeid (T));
      YY_ASSERT (sizeof (T) <= size);
      return *yyas_<T> ();
    }

    /// Const accessor to a built \a T (for %printer).
    template <typename T>
    const T&
    as () const YY_NOEXCEPT
    {
      YY_ASSERT (yytypeid_);
      YY_ASSERT (*yytypeid_ == typeid (T));
      YY_ASSERT (sizeof (T) <= size);
      return *yyas_<T> ();
    }

    /// Swap the content with \a that, of same type.
    ///
    /// Both variants must be built beforehand, because swapping the actual
    /// data requires reading it (with as()), and this is not possible on
    /// unconstructed variants: it would require some dynamic testing, which
    /// should not be the variant's responsibility.
    /// Swapping between built and (possibly) non-built is done with
    /// self_type::move ().
    template <typename T>
    void
    swap (self_type& that) YY_NOEXCEPT
    {
      YY_ASSERT (yytypeid_);
      YY_ASSERT (*yytypeid_ == *that.yytypeid_);
      std::swap (as<T> (), that.as<T> ());
    }

    /// Move the content of \a that to this.
    ///
    /// Destroys \a that.
    template <typename T>
    void
    move (self_type& that)
    {
# if 201103L <= YY_CPLUSPLUS
      emplace<T> (std::move (that.as<T> ()));
# else
      emplace<T> ();
      swap<T> (that);
# endif
      that.destroy<T> ();
    }

# if 201103L <= YY_CPLUSPLUS
    /// Move the content of \a that to this.
    template <typename T>
    void
    move (self_type&& that)
    {
      emplace<T> (std::move (that.as<T> ()));
      that.destroy<T> ();
    }
#endif

    /// Copy the content of \a that to this.
    template <typename T>
    void
    copy (const self_type& that)
    {
      emplace<T> (that.as<T> ());
    }

    /// Destroy the stored \a T.
    template <typename T>
    void
    destroy ()
    {
      as<T> ().~T ();
      yytypeid_ = YY_NULLPTR;
    }

  private:
#if YY_CPLUSPLUS < 201103L
    /// Non copyable.
    semantic_type (const self_type&);
    /// Non copyable.
    self_type& operator= (const self_type&);
#endif

    /// Accessor to raw memory as \a T.
    template <typename T>
    T*
    yyas_ () YY_NOEXCEPT
    {
      void *yyp = yybuffer_.yyraw;
      return static_cast<T*> (yyp);
     }

    /// Const accessor to raw memory as \a T.
    template <typename T>
    const T*
    yyas_ () const YY_NOEXCEPT
    {
      const void *yyp = yybuffer_.yyraw;
      return static_cast<const T*> (yyp);
     }

    /// An auxiliary type to compute the largest semantic type.
    union union_type
    {
      // qualifier
      char dummy1[sizeof (DeclQualifier)];

      // type
      char dummy2[sizeof (Type)];

      // "float_literal"
      char dummy3[sizeof (float)];

      // "int_literal"
      char dummy4[sizeof (int)];

      // decl
      // decl_body
      char dummy5[sizeof (shared_ptr<Decl>)];

      // dist
      char dummy6[sizeof (shared_ptr<Dist>)];

      // guard
      // exp
      char dummy7[sizeof (shared_ptr<Exp>)];

      // location
      char dummy8[sizeof (shared_ptr<Location>)];

      // model
      char dummy9[sizeof (shared_ptr<Model>)];

      // module
      char dummy10[sizeof (shared_ptr<ModuleAST>)];

      // prop
      char dummy11[sizeof (shared_ptr<Prop>)];

      // transition
      char dummy12[sizeof (shared_ptr<TransitionAST>)];

      // effects
      char dummy13[sizeof (shared_vector<Effect>)];

      // exp_seq
      char dummy14[sizeof (shared_vector<Exp>)];

      // pbranches
      char dummy15[sizeof (shared_vector<PBranch>)];

      // proplist
      char dummy16[sizeof (shared_vector<Prop>)];

      // "id"
      char dummy17[sizeof (std::string)];

      // qualifierlist
      char dummy18[sizeof (vector<DeclQualifier>)];
    };

    /// The size of the largest semantic type.
    enum { size = sizeof (union_type) };

    /// A buffer to store semantic values.
    union
    {
      /// Strongest alignment constraints.
      long double yyalign_me;
      /// A buffer large enough to store any of the semantic values.
      char yyraw[size];
    } yybuffer_;

    /// Whether the content is built: if defined, the name of the stored type.
    const std::type_info *yytypeid_;
  };

#else
    typedef YYSTYPE semantic_type;
#endif
    /// Symbol locations.
    typedef location location_type;

    /// Syntax errors thrown from user actions.
    struct syntax_error : std::runtime_error
    {
      syntax_error (const location_type& l, const std::string& m)
        : std::runtime_error (m)
        , location (l)
      {}

      syntax_error (const syntax_error& s)
        : std::runtime_error (s.what ())
        , location (s.location)
      {}

      ~syntax_error () YY_NOEXCEPT YY_NOTHROW;

      location_type location;
    };

    /// Token kinds.
    struct token
    {
      enum token_kind_type
      {
        TOK_YYEMPTY = -2,
    TOK_END = 0,                   // "end of file"
    TOK_YYerror = 256,             // error
    TOK_YYUNDEF = 257,             // "invalid token"
    TOK_COMMA = 258,               // ";"
    TOK_MODULE = 259,              // "module"
    TOK_ENDMODULE = 260,           // "endmodule"
    TOK_PROP = 261,                // "properties"
    TOK_ENDPROP = 262,             // "endproperties"
    TOK_TINT = 263,                // "int"
    TOK_TBOOL = 264,               // "bool"
    TOK_TFLOAT = 265,              // "float"
    TOK_CONST = 266,               // "const"
    TOK_LPAREN = 267,              // "("
    TOK_RPAREN = 268,              // ")"
    TOK_LBRACKET = 269,            // "["
    TOK_RBRACKET = 270,            // "]"
    TOK_LBRACE = 271,              // "{"
    TOK_RBRACE = 272,              // "}"
    TOK_CLOCK = 273,               // "clock"
    TOK_EQ = 274,                  // "="
    TOK_SQUOTE = 275,              // "'"
    TOK_SEMICOLON = 276,           // ":"
    TOK_COLON = 277,               // ","
    TOK_DOTDOT = 278,              // ".."
    TOK_AT = 279,                  // "@"
    TOK_ERLANG = 280,              // "erlang"
    TOK_NORMAL = 281,              // "normal"
    TOK_LOGNORMAL = 282,           // "lognormal"
    TOK_UNIFORM = 283,             // "uniform"
    TOK_EXP = 284,                 // "exponential"
    TOK_HEXP2 = 285,               // "hyperexponential2"
    TOK_WEIBULL = 286,             // "weibull"
    TOK_GAMMA = 287,               // "gamma"
    TOK_RAYLEIGH = 288,            // "rayleigh"
    TOK_DIRAC = 289,               // "dirac"
    TOK_INIT = 290,                // "init"
    TOK_EQQ = 291,                 // "=="
    TOK_NEQ = 292,                 // "!="
    TOK_LT = 293,                  // "<"
    TOK_GT = 294,                  // ">"
    TOK_LE = 295,                  // "<="
    TOK_GE = 296,                  // ">="
    TOK_IMPLY = 297,               // "=>"
    TOK_AND = 298,                 // "&"
    TOK_MID = 299,                 // "|"
    TOK_PLUS = 300,                // "+"
    TOK_MINUS = 301,               // "-"
    TOK_TIMES = 302,               // "*"
    TOK_MOD = 303,                 // "%"
    TOK_DIV = 304,                 // "/"
    TOK_QMARK = 305,               // "?"
    TOK_ADM = 306,                 // "!"
    TOK_ARROW = 307,               // "->"
    TOK_TRUE = 308,                // "true"
    TOK_FALSE = 309,               // "false"
    TOK_PROPT = 310,               // "P"
    TOK_PROPS = 311,               // "S"
    TOK_PROPB = 312,               // "B"
    TOK_UNTIL = 313,               // "U"
    TOK_FLOOR = 314,               // "floor"
    TOK_CEIL = 315,                // "ceil"
    TOK_SGN = 316,                 // "sgn"
    TOK_ABS = 317,                 // "abs"
    TOK_MIN = 318,                 // "min"
    TOK_MAX = 319,                 // "max"
    TOK_LOG = 320,                 // "log"
    TOK_POW = 321,                 // "pow"
    TOK_UNDERSCORE = 322,          // "_"
    TOK_FSTEQ = 323,               // "fsteq"
    TOK_LSTEQ = 324,               // "lsteq"
    TOK_RNDEQ = 325,               // "rndeq"
    TOK_MAXFROM = 326,             // "maxfrom"
    TOK_MINFROM = 327,             // "minfrom"
    TOK_SUMFROM = 328,             // "sumfrom"
    TOK_SUMKMAX = 329,             // "sumkmax"
    TOK_CONSEC = 330,              // "consec"
    TOK_BROKEN = 331,              // "broken"
    TOK_FSTEXCLUDE = 332,          // "fstexclude"
    TOK_UMINUS = 333,              // UMINUS
    TOK_NEG = 334,                 // NEG
    TOK_ID = 335,                  // "id"
    TOK_INTL = 336,                // "int_literal"
    TOK_FLOATL = 337               // "float_literal"
      };
      /// Backward compatibility alias (Bison 3.6).
      typedef token_kind_type yytokentype;
    };

    /// Token kind, as returned by yylex.
    typedef token::yytokentype token_kind_type;

    /// Backward compatibility alias (Bison 3.6).
    typedef token_kind_type token_type;

    /// Symbol kinds.
    struct symbol_kind
    {
      enum symbol_kind_type
      {
        YYNTOKENS = 83, ///< Number of tokens.
        S_YYEMPTY = -2,
        S_YYEOF = 0,                             // "end of file"
        S_YYerror = 1,                           // error
        S_YYUNDEF = 2,                           // "invalid token"
        S_COMMA = 3,                             // ";"
        S_MODULE = 4,                            // "module"
        S_ENDMODULE = 5,                         // "endmodule"
        S_PROP = 6,                              // "properties"
        S_ENDPROP = 7,                           // "endproperties"
        S_TINT = 8,                              // "int"
        S_TBOOL = 9,                             // "bool"
        S_TFLOAT = 10,                           // "float"
        S_CONST = 11,                            // "const"
        S_LPAREN = 12,                           // "("
        S_RPAREN = 13,                           // ")"
        S_LBRACKET = 14,                         // "["
        S_RBRACKET = 15,                         // "]"
        S_LBRACE = 16,                           // "{"
        S_RBRACE = 17,                           // "}"
        S_CLOCK = 18,                            // "clock"
        S_EQ = 19,                               // "="
        S_SQUOTE = 20,                           // "'"
        S_SEMICOLON = 21,                        // ":"
        S_COLON = 22,                            // ","
        S_DOTDOT = 23,                           // ".."
        S_AT = 24,                               // "@"
        S_ERLANG = 25,                           // "erlang"
        S_NORMAL = 26,                           // "normal"
        S_LOGNORMAL = 27,                        // "lognormal"
        S_UNIFORM = 28,                          // "uniform"
        S_EXP = 29,                              // "exponential"
        S_HEXP2 = 30,                            // "hyperexponential2"
        S_WEIBULL = 31,                          // "weibull"
        S_GAMMA = 32,                            // "gamma"
        S_RAYLEIGH = 33,                         // "rayleigh"
        S_DIRAC = 34,                            // "dirac"
        S_INIT = 35,                             // "init"
        S_EQQ = 36,                              // "=="
        S_NEQ = 37,                              // "!="
        S_LT = 38,                               // "<"
        S_GT = 39,                               // ">"
        S_LE = 40,                               // "<="
        S_GE = 41,                               // ">="
        S_IMPLY = 42,                            // "=>"
        S_AND = 43,                              // "&"
        S_MID = 44,                              // "|"
        S_PLUS = 45,                             // "+"
        S_MINUS = 46,                            // "-"
        S_TIMES = 47,                            // "*"
        S_MOD = 48,                              // "%"
        S_DIV = 49,                              // "/"
        S_QMARK = 50,                            // "?"
        S_ADM = 51,                              // "!"
        S_ARROW = 52,                            // "->"
        S_TRUE = 53,                             // "true"
        S_FALSE = 54,                            // "false"
        S_PROPT = 55,                            // "P"
        S_PROPS = 56,                            // "S"
        S_PROPB = 57,                            // "B"
        S_UNTIL = 58,                            // "U"
        S_FLOOR = 59,                            // "floor"
        S_CEIL = 60,                             // "ceil"
        S_SGN = 61,                              // "sgn"
        S_ABS = 62,                              // "abs"
        S_MIN = 63,                              // "min"
        S_MAX = 64,                              // "max"
        S_LOG = 65,                              // "log"
        S_POW = 66,                              // "pow"
        S_UNDERSCORE = 67,                       // "_"
        S_FSTEQ = 68,                            // "fsteq"
        S_LSTEQ = 69,                            // "lsteq"
        S_RNDEQ = 70,                            // "rndeq"
        S_MAXFROM = 71,                          // "maxfrom"
        S_MINFROM = 72,                          // "minfrom"
        S_SUMFROM = 73,                          // "sumfrom"
        S_SUMKMAX = 74,                          // "sumkmax"
        S_CONSEC = 75,                           // "consec"
        S_BROKEN = 76,                           // "broken"
        S_FSTEXCLUDE = 77,                       // "fstexclude"
        S_UMINUS = 78,                           // UMINUS
        S_NEG = 79,                              // NEG
        S_ID = 80,                               // "id"
        S_INTL = 81,                             // "int_literal"
        S_FLOATL = 82,                           // "float_literal"
        S_YYACCEPT = 83,                         // $accept
        S_begin = 84,                            // begin
        S_model = 85,                            // model
        S_prop = 86,                             // prop
        S_proplist = 87,                         // proplist
        S_type = 88,                             // type
        S_module = 89,                           // module
        S_qualifier = 90,                        // qualifier
        S_qualifierlist = 91,                    // qualifierlist
        S_decl = 92,                             // decl
        S_decl_body = 93,                        // decl_body
        S_exp_seq = 94,                          // exp_seq
        S_transition = 95,                       // transition
        S_location = 96,                         // location
        S_guard = 97,                            // guard
        S_pbranches = 98,                        // pbranches
        S_effects = 99,                          // effects
        S_dist = 100,                            // dist
        S_exp = 101                              // exp
      };
    };

    /// (Internal) symbol kind.
    typedef symbol_kind::symbol_kind_type symbol_kind_type;

    /// The number of tokens.
    static const symbol_kind_type YYNTOKENS = symbol_kind::YYNTOKENS;

    /// A complete symbol.
    ///
    /// Expects its Base type to provide access to the symbol kind
    /// via kind ().
    ///
    /// Provide access to semantic value and location.
    template <typename Base>
    struct basic_symbol : Base
    {
      /// Alias to Base.
      typedef Base super_type;

      /// Default constructor.
      basic_symbol ()
        : value ()
        , location ()
      {}

#if 201103L <= YY_CPLUSPLUS
      /// Move constructor.
      basic_symbol (basic_symbol&& that)
        : Base (std::move (that))
        , value ()
        , location (std::move (that.location))
      {
        switch (this->kind ())
    {
      case symbol_kind::S_qualifier: // qualifier
        value.move< DeclQualifier > (std::move (that.value));
        break;

      case symbol_kind::S_type: // type
        value.move< Type > (std::move (that.value));
        break;

      case symbol_kind::S_FLOATL: // "float_literal"
        value.move< float > (std::move (that.value));
        break;

      case symbol_kind::S_INTL: // "int_literal"
        value.move< int > (std::move (that.value));
        break;

      case symbol_kind::S_decl: // decl
      case symbol_kind::S_decl_body: // decl_body
        value.move< shared_ptr<Decl> > (std::move (that.value));
        break;

      case symbol_kind::S_dist: // dist
        value.move< shared_ptr<Dist> > (std::move (that.value));
        break;

      case symbol_kind::S_guard: // guard
      case symbol_kind::S_exp: // exp
        value.move< shared_ptr<Exp> > (std::move (that.value));
        break;

      case symbol_kind::S_location: // location
        value.move< shared_ptr<Location> > (std::move (that.value));
        break;

      case symbol_kind::S_model: // model
        value.move< shared_ptr<Model> > (std::move (that.value));
        break;

      case symbol_kind::S_module: // module
        value.move< shared_ptr<ModuleAST> > (std::move (that.value));
        break;

      case symbol_kind::S_prop: // prop
        value.move< shared_ptr<Prop> > (std::move (that.value));
        break;

      case symbol_kind::S_transition: // transition
        value.move< shared_ptr<TransitionAST> > (std::move (that.value));
        break;

      case symbol_kind::S_effects: // effects
        value.move< shared_vector<Effect> > (std::move (that.value));
        break;

      case symbol_kind::S_exp_seq: // exp_seq
        value.move< shared_vector<Exp> > (std::move (that.value));
        break;

      case symbol_kind::S_pbranches: // pbranches
        value.move< shared_vector<PBranch> > (std::move (that.value));
        break;

      case symbol_kind::S_proplist: // proplist
        value.move< shared_vector<Prop> > (std::move (that.value));
        break;

      case symbol_kind::S_ID: // "id"
        value.move< std::string > (std::move (that.value));
        break;

      case symbol_kind::S_qualifierlist: // qualifierlist
        value.move< vector<DeclQualifier> > (std::move (that.value));
        break;

      default:
        break;
    }

      }
#endif

      /// Copy constructor.
      basic_symbol (const basic_symbol& that);

      /// Constructor for valueless symbols, and symbols from each type.
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, location_type&& l)
        : Base (t)
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const location_type& l)
        : Base (t)
        , location (l)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, DeclQualifier&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const DeclQualifier& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Type&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Type& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, float&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const float& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, int&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const int& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, shared_ptr<Decl>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const shared_ptr<Decl>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, shared_ptr<Dist>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const shared_ptr<Dist>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, shared_ptr<Exp>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const shared_ptr<Exp>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, shared_ptr<Location>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const shared_ptr<Location>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, shared_ptr<Model>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const shared_ptr<Model>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, shared_ptr<ModuleAST>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const shared_ptr<ModuleAST>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, shared_ptr<Prop>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const shared_ptr<Prop>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, shared_ptr<TransitionAST>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const shared_ptr<TransitionAST>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, shared_vector<Effect>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const shared_vector<Effect>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, shared_vector<Exp>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const shared_vector<Exp>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, shared_vector<PBranch>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const shared_vector<PBranch>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, shared_vector<Prop>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const shared_vector<Prop>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::string&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::string& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, vector<DeclQualifier>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const vector<DeclQualifier>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

      /// Destroy the symbol.
      ~basic_symbol ()
      {
        clear ();
      }

      /// Destroy contents, and record that is empty.
      void clear ()
      {
        // User destructor.
        symbol_kind_type yykind = this->kind ();
        basic_symbol<Base>& yysym = *this;
        (void) yysym;
        switch (yykind)
        {
       default:
          break;
        }

        // Value type destructor.
switch (yykind)
    {
      case symbol_kind::S_qualifier: // qualifier
        value.template destroy< DeclQualifier > ();
        break;

      case symbol_kind::S_type: // type
        value.template destroy< Type > ();
        break;

      case symbol_kind::S_FLOATL: // "float_literal"
        value.template destroy< float > ();
        break;

      case symbol_kind::S_INTL: // "int_literal"
        value.template destroy< int > ();
        break;

      case symbol_kind::S_decl: // decl
      case symbol_kind::S_decl_body: // decl_body
        value.template destroy< shared_ptr<Decl> > ();
        break;

      case symbol_kind::S_dist: // dist
        value.template destroy< shared_ptr<Dist> > ();
        break;

      case symbol_kind::S_guard: // guard
      case symbol_kind::S_exp: // exp
        value.template destroy< shared_ptr<Exp> > ();
        break;

      case symbol_kind::S_location: // location
        value.template destroy< shared_ptr<Location> > ();
        break;

      case symbol_kind::S_model: // model
        value.template destroy< shared_ptr<Model> > ();
        break;

      case symbol_kind::S_module: // module
        value.template destroy< shared_ptr<ModuleAST> > ();
        break;

      case symbol_kind::S_prop: // prop
        value.template destroy< shared_ptr<Prop> > ();
        break;

      case symbol_kind::S_transition: // transition
        value.template destroy< shared_ptr<TransitionAST> > ();
        break;

      case symbol_kind::S_effects: // effects
        value.template destroy< shared_vector<Effect> > ();
        break;

      case symbol_kind::S_exp_seq: // exp_seq
        value.template destroy< shared_vector<Exp> > ();
        break;

      case symbol_kind::S_pbranches: // pbranches
        value.template destroy< shared_vector<PBranch> > ();
        break;

      case symbol_kind::S_proplist: // proplist
        value.template destroy< shared_vector<Prop> > ();
        break;

      case symbol_kind::S_ID: // "id"
        value.template destroy< std::string > ();
        break;

      case symbol_kind::S_qualifierlist: // qualifierlist
        value.template destroy< vector<DeclQualifier> > ();
        break;

      default:
        break;
    }

        Base::clear ();
      }

      /// The user-facing name of this symbol.
      std::string name () const YY_NOEXCEPT
      {
        return ModelParser::symbol_name (this->kind ());
      }

      /// Backward compatibility (Bison 3.6).
      symbol_kind_type type_get () const YY_NOEXCEPT;

      /// Whether empty.
      bool empty () const YY_NOEXCEPT;

      /// Destructive move, \a s is emptied into this.
      void move (basic_symbol& s);

      /// The semantic value.
      semantic_type value;

      /// The location.
      location_type location;

    private:
#if YY_CPLUSPLUS < 201103L
      /// Assignment operator.
      basic_symbol& operator= (const basic_symbol& that);
#endif
    };

    /// Type access provider for token (enum) based symbols.
    struct by_kind
    {
      /// Default constructor.
      by_kind ();

#if 201103L <= YY_CPLUSPLUS
      /// Move constructor.
      by_kind (by_kind&& that);
#endif

      /// Copy constructor.
      by_kind (const by_kind& that);

      /// The symbol kind as needed by the constructor.
      typedef token_kind_type kind_type;

      /// Constructor from (external) token numbers.
      by_kind (kind_type t);

      /// Record that this symbol is empty.
      void clear ();

      /// Steal the symbol kind from \a that.
      void move (by_kind& that);

      /// The (internal) type number (corresponding to \a type).
      /// \a empty when empty.
      symbol_kind_type kind () const YY_NOEXCEPT;

      /// Backward compatibility (Bison 3.6).
      symbol_kind_type type_get () const YY_NOEXCEPT;

      /// The symbol kind.
      /// \a S_YYEMPTY when empty.
      symbol_kind_type kind_;
    };

    /// Backward compatibility for a private implementation detail (Bison 3.6).
    typedef by_kind by_type;

    /// "External" symbols: returned by the scanner.
    struct symbol_type : basic_symbol<by_kind>
    {
      /// Superclass.
      typedef basic_symbol<by_kind> super_type;

      /// Empty symbol.
      symbol_type () {}

      /// Constructor for valueless symbols, and symbols from each type.
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok, location_type l)
        : super_type(token_type (tok), std::move (l))
      {
        YY_ASSERT (tok == token::TOK_END || tok == token::TOK_YYerror || tok == token::TOK_YYUNDEF || tok == token::TOK_COMMA || tok == token::TOK_MODULE || tok == token::TOK_ENDMODULE || tok == token::TOK_PROP || tok == token::TOK_ENDPROP || tok == token::TOK_TINT || tok == token::TOK_TBOOL || tok == token::TOK_TFLOAT || tok == token::TOK_CONST || tok == token::TOK_LPAREN || tok == token::TOK_RPAREN || tok == token::TOK_LBRACKET || tok == token::TOK_RBRACKET || tok == token::TOK_LBRACE || tok == token::TOK_RBRACE || tok == token::TOK_CLOCK || tok == token::TOK_EQ || tok == token::TOK_SQUOTE || tok == token::TOK_SEMICOLON || tok == token::TOK_COLON || tok == token::TOK_DOTDOT || tok == token::TOK_AT || tok == token::TOK_ERLANG || tok == token::TOK_NORMAL || tok == token::TOK_LOGNORMAL || tok == token::TOK_UNIFORM || tok == token::TOK_EXP || tok == token::TOK_HEXP2 || tok == token::TOK_WEIBULL || tok == token::TOK_GAMMA || tok == token::TOK_RAYLEIGH || tok == token::TOK_DIRAC || tok == token::TOK_INIT || tok == token::TOK_EQQ || tok == token::TOK_NEQ || tok == token::TOK_LT || tok == token::TOK_GT || tok == token::TOK_LE || tok == token::TOK_GE || tok == token::TOK_IMPLY || tok == token::TOK_AND || tok == token::TOK_MID || tok == token::TOK_PLUS || tok == token::TOK_MINUS || tok == token::TOK_TIMES || tok == token::TOK_MOD || tok == token::TOK_DIV || tok == token::TOK_QMARK || tok == token::TOK_ADM || tok == token::TOK_ARROW || tok == token::TOK_TRUE || tok == token::TOK_FALSE || tok == token::TOK_PROPT || tok == token::TOK_PROPS || tok == token::TOK_PROPB || tok == token::TOK_UNTIL || tok == token::TOK_FLOOR || tok == token::TOK_CEIL || tok == token::TOK_SGN || tok == token::TOK_ABS || tok == token::TOK_MIN || tok == token::TOK_MAX || tok == token::TOK_LOG || tok == token::TOK_POW || tok == token::TOK_UNDERSCORE || tok == token::TOK_FSTEQ || tok == token::TOK_LSTEQ || tok == token::TOK_RNDEQ || tok == token::TOK_MAXFROM || tok == token::TOK_MINFROM || tok == token::TOK_SUMFROM || tok == token::TOK_SUMKMAX || tok == token::TOK_CONSEC || tok == token::TOK_BROKEN || tok == token::TOK_FSTEXCLUDE || tok == token::TOK_UMINUS || tok == token::TOK_NEG);
      }
#else
      symbol_type (int tok, const location_type& l)
        : super_type(token_type (tok), l)
      {
        YY_ASSERT (tok == token::TOK_END || tok == token::TOK_YYerror || tok == token::TOK_YYUNDEF || tok == token::TOK_COMMA || tok == token::TOK_MODULE || tok == token::TOK_ENDMODULE || tok == token::TOK_PROP || tok == token::TOK_ENDPROP || tok == token::TOK_TINT || tok == token::TOK_TBOOL || tok == token::TOK_TFLOAT || tok == token::TOK_CONST || tok == token::TOK_LPAREN || tok == token::TOK_RPAREN || tok == token::TOK_LBRACKET || tok == token::TOK_RBRACKET || tok == token::TOK_LBRACE || tok == token::TOK_RBRACE || tok == token::TOK_CLOCK || tok == token::TOK_EQ || tok == token::TOK_SQUOTE || tok == token::TOK_SEMICOLON || tok == token::TOK_COLON || tok == token::TOK_DOTDOT || tok == token::TOK_AT || tok == token::TOK_ERLANG || tok == token::TOK_NORMAL || tok == token::TOK_LOGNORMAL || tok == token::TOK_UNIFORM || tok == token::TOK_EXP || tok == token::TOK_HEXP2 || tok == token::TOK_WEIBULL || tok == token::TOK_GAMMA || tok == token::TOK_RAYLEIGH || tok == token::TOK_DIRAC || tok == token::TOK_INIT || tok == token::TOK_EQQ || tok == token::TOK_NEQ || tok == token::TOK_LT || tok == token::TOK_GT || tok == token::TOK_LE || tok == token::TOK_GE || tok == token::TOK_IMPLY || tok == token::TOK_AND || tok == token::TOK_MID || tok == token::TOK_PLUS || tok == token::TOK_MINUS || tok == token::TOK_TIMES || tok == token::TOK_MOD || tok == token::TOK_DIV || tok == token::TOK_QMARK || tok == token::TOK_ADM || tok == token::TOK_ARROW || tok == token::TOK_TRUE || tok == token::TOK_FALSE || tok == token::TOK_PROPT || tok == token::TOK_PROPS || tok == token::TOK_PROPB || tok == token::TOK_UNTIL || tok == token::TOK_FLOOR || tok == token::TOK_CEIL || tok == token::TOK_SGN || tok == token::TOK_ABS || tok == token::TOK_MIN || tok == token::TOK_MAX || tok == token::TOK_LOG || tok == token::TOK_POW || tok == token::TOK_UNDERSCORE || tok == token::TOK_FSTEQ || tok == token::TOK_LSTEQ || tok == token::TOK_RNDEQ || tok == token::TOK_MAXFROM || tok == token::TOK_MINFROM || tok == token::TOK_SUMFROM || tok == token::TOK_SUMKMAX || tok == token::TOK_CONSEC || tok == token::TOK_BROKEN || tok == token::TOK_FSTEXCLUDE || tok == token::TOK_UMINUS || tok == token::TOK_NEG);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok, float v, location_type l)
        : super_type(token_type (tok), std::move (v), std::move (l))
      {
        YY_ASSERT (tok == token::TOK_FLOATL);
      }
#else
      symbol_type (int tok, const float& v, const location_type& l)
        : super_type(token_type (tok), v, l)
      {
        YY_ASSERT (tok == token::TOK_FLOATL);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok, int v, location_type l)
        : super_type(token_type (tok), std::move (v), std::move (l))
      {
        YY_ASSERT (tok == token::TOK_INTL);
      }
#else
      symbol_type (int tok, const int& v, const location_type& l)
        : super_type(token_type (tok), v, l)
      {
        YY_ASSERT (tok == token::TOK_INTL);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok, std::string v, location_type l)
        : super_type(token_type (tok), std::move (v), std::move (l))
      {
        YY_ASSERT (tok == token::TOK_ID);
      }
#else
      symbol_type (int tok, const std::string& v, const location_type& l)
        : super_type(token_type (tok), v, l)
      {
        YY_ASSERT (tok == token::TOK_ID);
      }
#endif
    };

    /// Build a parser object.
    ModelParser (shared_ptr<ModelAST> *result_yyarg);
    virtual ~ModelParser ();

#if 201103L <= YY_CPLUSPLUS
    /// Non copyable.
    ModelParser (const ModelParser&) = delete;
    /// Non copyable.
    ModelParser& operator= (const ModelParser&) = delete;
#endif

    /// Parse.  An alias for parse ().
    /// \returns  0 iff parsing succeeded.
    int operator() ();

    /// Parse.
    /// \returns  0 iff parsing succeeded.
    virtual int parse ();

#if YYDEBUG
    /// The current debugging stream.
    std::ostream& debug_stream () const YY_ATTRIBUTE_PURE;
    /// Set the current debugging stream.
    void set_debug_stream (std::ostream &);

    /// Type for debugging levels.
    typedef int debug_level_type;
    /// The current debugging level.
    debug_level_type debug_level () const YY_ATTRIBUTE_PURE;
    /// Set the current debugging level.
    void set_debug_level (debug_level_type l);
#endif

    /// Report a syntax error.
    /// \param loc    where the syntax error is found.
    /// \param msg    a description of the syntax error.
    virtual void error (const location_type& loc, const std::string& msg);

    /// Report a syntax error.
    void error (const syntax_error& err);

    /// The user-facing name of the symbol whose (internal) number is
    /// YYSYMBOL.  No bounds checking.
    static std::string symbol_name (symbol_kind_type yysymbol);

    // Implementation of make_symbol for each symbol type.
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_END (location_type l)
      {
        return symbol_type (token::TOK_END, std::move (l));
      }
#else
      static
      symbol_type
      make_END (const location_type& l)
      {
        return symbol_type (token::TOK_END, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_YYerror (location_type l)
      {
        return symbol_type (token::TOK_YYerror, std::move (l));
      }
#else
      static
      symbol_type
      make_YYerror (const location_type& l)
      {
        return symbol_type (token::TOK_YYerror, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_YYUNDEF (location_type l)
      {
        return symbol_type (token::TOK_YYUNDEF, std::move (l));
      }
#else
      static
      symbol_type
      make_YYUNDEF (const location_type& l)
      {
        return symbol_type (token::TOK_YYUNDEF, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_COMMA (location_type l)
      {
        return symbol_type (token::TOK_COMMA, std::move (l));
      }
#else
      static
      symbol_type
      make_COMMA (const location_type& l)
      {
        return symbol_type (token::TOK_COMMA, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MODULE (location_type l)
      {
        return symbol_type (token::TOK_MODULE, std::move (l));
      }
#else
      static
      symbol_type
      make_MODULE (const location_type& l)
      {
        return symbol_type (token::TOK_MODULE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ENDMODULE (location_type l)
      {
        return symbol_type (token::TOK_ENDMODULE, std::move (l));
      }
#else
      static
      symbol_type
      make_ENDMODULE (const location_type& l)
      {
        return symbol_type (token::TOK_ENDMODULE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PROP (location_type l)
      {
        return symbol_type (token::TOK_PROP, std::move (l));
      }
#else
      static
      symbol_type
      make_PROP (const location_type& l)
      {
        return symbol_type (token::TOK_PROP, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ENDPROP (location_type l)
      {
        return symbol_type (token::TOK_ENDPROP, std::move (l));
      }
#else
      static
      symbol_type
      make_ENDPROP (const location_type& l)
      {
        return symbol_type (token::TOK_ENDPROP, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TINT (location_type l)
      {
        return symbol_type (token::TOK_TINT, std::move (l));
      }
#else
      static
      symbol_type
      make_TINT (const location_type& l)
      {
        return symbol_type (token::TOK_TINT, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TBOOL (location_type l)
      {
        return symbol_type (token::TOK_TBOOL, std::move (l));
      }
#else
      static
      symbol_type
      make_TBOOL (const location_type& l)
      {
        return symbol_type (token::TOK_TBOOL, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TFLOAT (location_type l)
      {
        return symbol_type (token::TOK_TFLOAT, std::move (l));
      }
#else
      static
      symbol_type
      make_TFLOAT (const location_type& l)
      {
        return symbol_type (token::TOK_TFLOAT, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_CONST (location_type l)
      {
        return symbol_type (token::TOK_CONST, std::move (l));
      }
#else
      static
      symbol_type
      make_CONST (const location_type& l)
      {
        return symbol_type (token::TOK_CONST, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LPAREN (location_type l)
      {
        return symbol_type (token::TOK_LPAREN, std::move (l));
      }
#else
      static
      symbol_type
      make_LPAREN (const location_type& l)
      {
        return symbol_type (token::TOK_LPAREN, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RPAREN (location_type l)
      {
        return symbol_type (token::TOK_RPAREN, std::move (l));
      }
#else
      static
      symbol_type
      make_RPAREN (const location_type& l)
      {
        return symbol_type (token::TOK_RPAREN, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LBRACKET (location_type l)
      {
        return symbol_type (token::TOK_LBRACKET, std::move (l));
      }
#else
      static
      symbol_type
      make_LBRACKET (const location_type& l)
      {
        return symbol_type (token::TOK_LBRACKET, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RBRACKET (location_type l)
      {
        return symbol_type (token::TOK_RBRACKET, std::move (l));
      }
#else
      static
      symbol_type
      make_RBRACKET (const location_type& l)
      {
        return symbol_type (token::TOK_RBRACKET, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LBRACE (location_type l)
      {
        return symbol_type (token::TOK_LBRACE, std::move (l));
      }
#else
      static
      symbol_type
      make_LBRACE (const location_type& l)
      {
        return symbol_type (token::TOK_LBRACE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RBRACE (location_type l)
      {
        return symbol_type (token::TOK_RBRACE, std::move (l));
      }
#else
      static
      symbol_type
      make_RBRACE (const location_type& l)
      {
        return symbol_type (token::TOK_RBRACE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_CLOCK (location_type l)
      {
        return symbol_type (token::TOK_CLOCK, std::move (l));
      }
#else
      static
      symbol_type
      make_CLOCK (const location_type& l)
      {
        return symbol_type (token::TOK_CLOCK, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_EQ (location_type l)
      {
        return symbol_type (token::TOK_EQ, std::move (l));
      }
#else
      static
      symbol_type
      make_EQ (const location_type& l)
      {
        return symbol_type (token::TOK_EQ, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SQUOTE (location_type l)
      {
        return symbol_type (token::TOK_SQUOTE, std::move (l));
      }
#else
      static
      symbol_type
      make_SQUOTE (const location_type& l)
      {
        return symbol_type (token::TOK_SQUOTE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SEMICOLON (location_type l)
      {
        return symbol_type (token::TOK_SEMICOLON, std::move (l));
      }
#else
      static
      symbol_type
      make_SEMICOLON (const location_type& l)
      {
        return symbol_type (token::TOK_SEMICOLON, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_COLON (location_type l)
      {
        return symbol_type (token::TOK_COLON, std::move (l));
      }
#else
      static
      symbol_type
      make_COLON (const location_type& l)
      {
        return symbol_type (token::TOK_COLON, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_DOTDOT (location_type l)
      {
        return symbol_type (token::TOK_DOTDOT, std::move (l));
      }
#else
      static
      symbol_type
      make_DOTDOT (const location_type& l)
      {
        return symbol_type (token::TOK_DOTDOT, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_AT (location_type l)
      {
        return symbol_type (token::TOK_AT, std::move (l));
      }
#else
      static
      symbol_type
      make_AT (const location_type& l)
      {
        return symbol_type (token::TOK_AT, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ERLANG (location_type l)
      {
        return symbol_type (token::TOK_ERLANG, std::move (l));
      }
#else
      static
      symbol_type
      make_ERLANG (const location_type& l)
      {
        return symbol_type (token::TOK_ERLANG, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_NORMAL (location_type l)
      {
        return symbol_type (token::TOK_NORMAL, std::move (l));
      }
#else
      static
      symbol_type
      make_NORMAL (const location_type& l)
      {
        return symbol_type (token::TOK_NORMAL, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LOGNORMAL (location_type l)
      {
        return symbol_type (token::TOK_LOGNORMAL, std::move (l));
      }
#else
      static
      symbol_type
      make_LOGNORMAL (const location_type& l)
      {
        return symbol_type (token::TOK_LOGNORMAL, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_UNIFORM (location_type l)
      {
        return symbol_type (token::TOK_UNIFORM, std::move (l));
      }
#else
      static
      symbol_type
      make_UNIFORM (const location_type& l)
      {
        return symbol_type (token::TOK_UNIFORM, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_EXP (location_type l)
      {
        return symbol_type (token::TOK_EXP, std::move (l));
      }
#else
      static
      symbol_type
      make_EXP (const location_type& l)
      {
        return symbol_type (token::TOK_EXP, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_HEXP2 (location_type l)
      {
        return symbol_type (token::TOK_HEXP2, std::move (l));
      }
#else
      static
      symbol_type
      make_HEXP2 (const location_type& l)
      {
        return symbol_type (token::TOK_HEXP2, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_WEIBULL (location_type l)
      {
        return symbol_type (token::TOK_WEIBULL, std::move (l));
      }
#else
      static
      symbol_type
      make_WEIBULL (const location_type& l)
      {
        return symbol_type (token::TOK_WEIBULL, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_GAMMA (location_type l)
      {
        return symbol_type (token::TOK_GAMMA, std::move (l));
      }
#else
      static
      symbol_type
      make_GAMMA (const location_type& l)
      {
        return symbol_type (token::TOK_GAMMA, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RAYLEIGH (location_type l)
      {
        return symbol_type (token::TOK_RAYLEIGH, std::move (l));
      }
#else
      static
      symbol_type
      make_RAYLEIGH (const location_type& l)
      {
        return symbol_type (token::TOK_RAYLEIGH, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_DIRAC (location_type l)
      {
        return symbol_type (token::TOK_DIRAC, std::move (l));
      }
#else
      static
      symbol_type
      make_DIRAC (const location_type& l)
      {
        return symbol_type (token::TOK_DIRAC, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_INIT (location_type l)
      {
        return symbol_type (token::TOK_INIT, std::move (l));
      }
#else
      static
      symbol_type
      make_INIT (const location_type& l)
      {
        return symbol_type (token::TOK_INIT, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_EQQ (location_type l)
      {
        return symbol_type (token::TOK_EQQ, std::move (l));
      }
#else
      static
      symbol_type
      make_EQQ (const location_type& l)
      {
        return symbol_type (token::TOK_EQQ, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_NEQ (location_type l)
      {
        return symbol_type (token::TOK_NEQ, std::move (l));
      }
#else
      static
      symbol_type
      make_NEQ (const location_type& l)
      {
        return symbol_type (token::TOK_NEQ, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LT (location_type l)
      {
        return symbol_type (token::TOK_LT, std::move (l));
      }
#else
      static
      symbol_type
      make_LT (const location_type& l)
      {
        return symbol_type (token::TOK_LT, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_GT (location_type l)
      {
        return symbol_type (token::TOK_GT, std::move (l));
      }
#else
      static
      symbol_type
      make_GT (const location_type& l)
      {
        return symbol_type (token::TOK_GT, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LE (location_type l)
      {
        return symbol_type (token::TOK_LE, std::move (l));
      }
#else
      static
      symbol_type
      make_LE (const location_type& l)
      {
        return symbol_type (token::TOK_LE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_GE (location_type l)
      {
        return symbol_type (token::TOK_GE, std::move (l));
      }
#else
      static
      symbol_type
      make_GE (const location_type& l)
      {
        return symbol_type (token::TOK_GE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_IMPLY (location_type l)
      {
        return symbol_type (token::TOK_IMPLY, std::move (l));
      }
#else
      static
      symbol_type
      make_IMPLY (const location_type& l)
      {
        return symbol_type (token::TOK_IMPLY, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_AND (location_type l)
      {
        return symbol_type (token::TOK_AND, std::move (l));
      }
#else
      static
      symbol_type
      make_AND (const location_type& l)
      {
        return symbol_type (token::TOK_AND, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MID (location_type l)
      {
        return symbol_type (token::TOK_MID, std::move (l));
      }
#else
      static
      symbol_type
      make_MID (const location_type& l)
      {
        return symbol_type (token::TOK_MID, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PLUS (location_type l)
      {
        return symbol_type (token::TOK_PLUS, std::move (l));
      }
#else
      static
      symbol_type
      make_PLUS (const location_type& l)
      {
        return symbol_type (token::TOK_PLUS, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MINUS (location_type l)
      {
        return symbol_type (token::TOK_MINUS, std::move (l));
      }
#else
      static
      symbol_type
      make_MINUS (const location_type& l)
      {
        return symbol_type (token::TOK_MINUS, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TIMES (location_type l)
      {
        return symbol_type (token::TOK_TIMES, std::move (l));
      }
#else
      static
      symbol_type
      make_TIMES (const location_type& l)
      {
        return symbol_type (token::TOK_TIMES, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MOD (location_type l)
      {
        return symbol_type (token::TOK_MOD, std::move (l));
      }
#else
      static
      symbol_type
      make_MOD (const location_type& l)
      {
        return symbol_type (token::TOK_MOD, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_DIV (location_type l)
      {
        return symbol_type (token::TOK_DIV, std::move (l));
      }
#else
      static
      symbol_type
      make_DIV (const location_type& l)
      {
        return symbol_type (token::TOK_DIV, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_QMARK (location_type l)
      {
        return symbol_type (token::TOK_QMARK, std::move (l));
      }
#else
      static
      symbol_type
      make_QMARK (const location_type& l)
      {
        return symbol_type (token::TOK_QMARK, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ADM (location_type l)
      {
        return symbol_type (token::TOK_ADM, std::move (l));
      }
#else
      static
      symbol_type
      make_ADM (const location_type& l)
      {
        return symbol_type (token::TOK_ADM, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ARROW (location_type l)
      {
        return symbol_type (token::TOK_ARROW, std::move (l));
      }
#else
      static
      symbol_type
      make_ARROW (const location_type& l)
      {
        return symbol_type (token::TOK_ARROW, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TRUE (location_type l)
      {
        return symbol_type (token::TOK_TRUE, std::move (l));
      }
#else
      static
      symbol_type
      make_TRUE (const location_type& l)
      {
        return symbol_type (token::TOK_TRUE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_FALSE (location_type l)
      {
        return symbol_type (token::TOK_FALSE, std::move (l));
      }
#else
      static
      symbol_type
      make_FALSE (const location_type& l)
      {
        return symbol_type (token::TOK_FALSE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PROPT (location_type l)
      {
        return symbol_type (token::TOK_PROPT, std::move (l));
      }
#else
      static
      symbol_type
      make_PROPT (const location_type& l)
      {
        return symbol_type (token::TOK_PROPT, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PROPS (location_type l)
      {
        return symbol_type (token::TOK_PROPS, std::move (l));
      }
#else
      static
      symbol_type
      make_PROPS (const location_type& l)
      {
        return symbol_type (token::TOK_PROPS, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PROPB (location_type l)
      {
        return symbol_type (token::TOK_PROPB, std::move (l));
      }
#else
      static
      symbol_type
      make_PROPB (const location_type& l)
      {
        return symbol_type (token::TOK_PROPB, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_UNTIL (location_type l)
      {
        return symbol_type (token::TOK_UNTIL, std::move (l));
      }
#else
      static
      symbol_type
      make_UNTIL (const location_type& l)
      {
        return symbol_type (token::TOK_UNTIL, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_FLOOR (location_type l)
      {
        return symbol_type (token::TOK_FLOOR, std::move (l));
      }
#else
      static
      symbol_type
      make_FLOOR (const location_type& l)
      {
        return symbol_type (token::TOK_FLOOR, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_CEIL (location_type l)
      {
        return symbol_type (token::TOK_CEIL, std::move (l));
      }
#else
      static
      symbol_type
      make_CEIL (const location_type& l)
      {
        return symbol_type (token::TOK_CEIL, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SGN (location_type l)
      {
        return symbol_type (token::TOK_SGN, std::move (l));
      }
#else
      static
      symbol_type
      make_SGN (const location_type& l)
      {
        return symbol_type (token::TOK_SGN, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ABS (location_type l)
      {
        return symbol_type (token::TOK_ABS, std::move (l));
      }
#else
      static
      symbol_type
      make_ABS (const location_type& l)
      {
        return symbol_type (token::TOK_ABS, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MIN (location_type l)
      {
        return symbol_type (token::TOK_MIN, std::move (l));
      }
#else
      static
      symbol_type
      make_MIN (const location_type& l)
      {
        return symbol_type (token::TOK_MIN, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MAX (location_type l)
      {
        return symbol_type (token::TOK_MAX, std::move (l));
      }
#else
      static
      symbol_type
      make_MAX (const location_type& l)
      {
        return symbol_type (token::TOK_MAX, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LOG (location_type l)
      {
        return symbol_type (token::TOK_LOG, std::move (l));
      }
#else
      static
      symbol_type
      make_LOG (const location_type& l)
      {
        return symbol_type (token::TOK_LOG, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POW (location_type l)
      {
        return symbol_type (token::TOK_POW, std::move (l));
      }
#else
      static
      symbol_type
      make_POW (const location_type& l)
      {
        return symbol_type (token::TOK_POW, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_UNDERSCORE (location_type l)
      {
        return symbol_type (token::TOK_UNDERSCORE, std::move (l));
      }
#else
      static
      symbol_type
      make_UNDERSCORE (const location_type& l)
      {
        return symbol_type (token::TOK_UNDERSCORE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_FSTEQ (location_type l)
      {
        return symbol_type (token::TOK_FSTEQ, std::move (l));
      }
#else
      static
      symbol_type
      make_FSTEQ (const location_type& l)
      {
        return symbol_type (token::TOK_FSTEQ, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LSTEQ (location_type l)
      {
        return symbol_type (token::TOK_LSTEQ, std::move (l));
      }
#else
      static
      symbol_type
      make_LSTEQ (const location_type& l)
      {
        return symbol_type (token::TOK_LSTEQ, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RNDEQ (location_type l)
      {
        return symbol_type (token::TOK_RNDEQ, std::move (l));
      }
#else
      static
      symbol_type
      make_RNDEQ (const location_type& l)
      {
        return symbol_type (token::TOK_RNDEQ, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MAXFROM (location_type l)
      {
        return symbol_type (token::TOK_MAXFROM, std::move (l));
      }
#else
      static
      symbol_type
      make_MAXFROM (const location_type& l)
      {
        return symbol_type (token::TOK_MAXFROM, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MINFROM (location_type l)
      {
        return symbol_type (token::TOK_MINFROM, std::move (l));
      }
#else
      static
      symbol_type
      make_MINFROM (const location_type& l)
      {
        return symbol_type (token::TOK_MINFROM, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SUMFROM (location_type l)
      {
        return symbol_type (token::TOK_SUMFROM, std::move (l));
      }
#else
      static
      symbol_type
      make_SUMFROM (const location_type& l)
      {
        return symbol_type (token::TOK_SUMFROM, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SUMKMAX (location_type l)
      {
        return symbol_type (token::TOK_SUMKMAX, std::move (l));
      }
#else
      static
      symbol_type
      make_SUMKMAX (const location_type& l)
      {
        return symbol_type (token::TOK_SUMKMAX, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_CONSEC (location_type l)
      {
        return symbol_type (token::TOK_CONSEC, std::move (l));
      }
#else
      static
      symbol_type
      make_CONSEC (const location_type& l)
      {
        return symbol_type (token::TOK_CONSEC, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_BROKEN (location_type l)
      {
        return symbol_type (token::TOK_BROKEN, std::move (l));
      }
#else
      static
      symbol_type
      make_BROKEN (const location_type& l)
      {
        return symbol_type (token::TOK_BROKEN, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_FSTEXCLUDE (location_type l)
      {
        return symbol_type (token::TOK_FSTEXCLUDE, std::move (l));
      }
#else
      static
      symbol_type
      make_FSTEXCLUDE (const location_type& l)
      {
        return symbol_type (token::TOK_FSTEXCLUDE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_UMINUS (location_type l)
      {
        return symbol_type (token::TOK_UMINUS, std::move (l));
      }
#else
      static
      symbol_type
      make_UMINUS (const location_type& l)
      {
        return symbol_type (token::TOK_UMINUS, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_NEG (location_type l)
      {
        return symbol_type (token::TOK_NEG, std::move (l));
      }
#else
      static
      symbol_type
      make_NEG (const location_type& l)
      {
        return symbol_type (token::TOK_NEG, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ID (std::string v, location_type l)
      {
        return symbol_type (token::TOK_ID, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_ID (const std::string& v, const location_type& l)
      {
        return symbol_type (token::TOK_ID, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_INTL (int v, location_type l)
      {
        return symbol_type (token::TOK_INTL, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_INTL (const int& v, const location_type& l)
      {
        return symbol_type (token::TOK_INTL, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_FLOATL (float v, location_type l)
      {
        return symbol_type (token::TOK_FLOATL, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_FLOATL (const float& v, const location_type& l)
      {
        return symbol_type (token::TOK_FLOATL, v, l);
      }
#endif


    class context
    {
    public:
      context (const ModelParser& yyparser, const symbol_type& yyla);
      const symbol_type& lookahead () const { return yyla_; }
      symbol_kind_type token () const { return yyla_.kind (); }
      const location_type& location () const { return yyla_.location; }

      /// Put in YYARG at most YYARGN of the expected tokens, and return the
      /// number of tokens stored in YYARG.  If YYARG is null, return the
      /// number of expected tokens (guaranteed to be less than YYNTOKENS).
      int expected_tokens (symbol_kind_type yyarg[], int yyargn) const;

    private:
      const ModelParser& yyparser_;
      const symbol_type& yyla_;
    };

  private:
#if YY_CPLUSPLUS < 201103L
    /// Non copyable.
    ModelParser (const ModelParser&);
    /// Non copyable.
    ModelParser& operator= (const ModelParser&);
#endif


    /// Stored state numbers (used for stacks).
    typedef short state_type;

    /// The arguments of the error message.
    int yy_syntax_error_arguments_ (const context& yyctx,
                                    symbol_kind_type yyarg[], int yyargn) const;

    /// Generate an error message.
    /// \param yyctx     the context in which the error occurred.
    virtual std::string yysyntax_error_ (const context& yyctx) const;
    /// Compute post-reduction state.
    /// \param yystate   the current state
    /// \param yysym     the nonterminal to push on the stack
    static state_type yy_lr_goto_state_ (state_type yystate, int yysym);

    /// Whether the given \c yypact_ value indicates a defaulted state.
    /// \param yyvalue   the value to check
    static bool yy_pact_value_is_default_ (int yyvalue);

    /// Whether the given \c yytable_ value indicates a syntax error.
    /// \param yyvalue   the value to check
    static bool yy_table_value_is_error_ (int yyvalue);

    static const short yypact_ninf_;
    static const signed char yytable_ninf_;

    /// Convert a scanner token kind \a t to a symbol kind.
    /// In theory \a t should be a token_kind_type, but character literals
    /// are valid, yet not members of the token_type enum.
    static symbol_kind_type yytranslate_ (int t);

    /// Convert the symbol name \a n to a form suitable for a diagnostic.
    static std::string yytnamerr_ (const char *yystr);

    /// For a symbol, its name in clear.
    static const char* const yytname_[];


    // Tables.
    // YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
    // STATE-NUM.
    static const short yypact_[];

    // YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
    // Performed when YYTABLE does not specify something else to do.  Zero
    // means the default is an error.
    static const signed char yydefact_[];

    // YYPGOTO[NTERM-NUM].
    static const short yypgoto_[];

    // YYDEFGOTO[NTERM-NUM].
    static const short yydefgoto_[];

    // YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
    // positive, shift that token.  If negative, reduce the rule whose
    // number is the opposite.  If YYTABLE_NINF, syntax error.
    static const short yytable_[];

    static const short yycheck_[];

    // YYSTOS[STATE-NUM] -- The (internal number of the) accessing
    // symbol of state STATE-NUM.
    static const signed char yystos_[];

    // YYR1[YYN] -- Symbol number of symbol that rule YYN derives.
    static const signed char yyr1_[];

    // YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.
    static const signed char yyr2_[];


#if YYDEBUG
    // YYRLINE[YYN] -- Source line where rule number YYN was defined.
    static const short yyrline_[];
    /// Report on the debug stream that the rule \a r is going to be reduced.
    virtual void yy_reduce_print_ (int r) const;
    /// Print the state stack on the debug stream.
    virtual void yy_stack_print_ () const;

    /// Debugging level.
    int yydebug_;
    /// Debug stream.
    std::ostream* yycdebug_;

    /// \brief Display a symbol kind, value and location.
    /// \param yyo    The output stream.
    /// \param yysym  The symbol.
    template <typename Base>
    void yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const;
#endif

    /// \brief Reclaim the memory associated to a symbol.
    /// \param yymsg     Why this token is reclaimed.
    ///                  If null, print nothing.
    /// \param yysym     The symbol.
    template <typename Base>
    void yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const;

  private:
    /// Type access provider for state based symbols.
    struct by_state
    {
      /// Default constructor.
      by_state () YY_NOEXCEPT;

      /// The symbol kind as needed by the constructor.
      typedef state_type kind_type;

      /// Constructor.
      by_state (kind_type s) YY_NOEXCEPT;

      /// Copy constructor.
      by_state (const by_state& that) YY_NOEXCEPT;

      /// Record that this symbol is empty.
      void clear () YY_NOEXCEPT;

      /// Steal the symbol kind from \a that.
      void move (by_state& that);

      /// The symbol kind (corresponding to \a state).
      /// \a symbol_kind::S_YYEMPTY when empty.
      symbol_kind_type kind () const YY_NOEXCEPT;

      /// The state number used to denote an empty symbol.
      /// We use the initial state, as it does not have a value.
      enum { empty_state = 0 };

      /// The state.
      /// \a empty when empty.
      state_type state;
    };

    /// "Internal" symbol: element of the stack.
    struct stack_symbol_type : basic_symbol<by_state>
    {
      /// Superclass.
      typedef basic_symbol<by_state> super_type;
      /// Construct an empty symbol.
      stack_symbol_type ();
      /// Move or copy construction.
      stack_symbol_type (YY_RVREF (stack_symbol_type) that);
      /// Steal the contents from \a sym to build this.
      stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) sym);
#if YY_CPLUSPLUS < 201103L
      /// Assignment, needed by push_back by some old implementations.
      /// Moves the contents of that.
      stack_symbol_type& operator= (stack_symbol_type& that);

      /// Assignment, needed by push_back by other implementations.
      /// Needed by some other old implementations.
      stack_symbol_type& operator= (const stack_symbol_type& that);
#endif
    };

    /// A stack with random access from its top.
    template <typename T, typename S = std::vector<T> >
    class stack
    {
    public:
      // Hide our reversed order.
      typedef typename S::iterator iterator;
      typedef typename S::const_iterator const_iterator;
      typedef typename S::size_type size_type;
      typedef typename std::ptrdiff_t index_type;

      stack (size_type n = 200)
        : seq_ (n)
      {}

#if 201103L <= YY_CPLUSPLUS
      /// Non copyable.
      stack (const stack&) = delete;
      /// Non copyable.
      stack& operator= (const stack&) = delete;
#endif

      /// Random access.
      ///
      /// Index 0 returns the topmost element.
      const T&
      operator[] (index_type i) const
      {
        return seq_[size_type (size () - 1 - i)];
      }

      /// Random access.
      ///
      /// Index 0 returns the topmost element.
      T&
      operator[] (index_type i)
      {
        return seq_[size_type (size () - 1 - i)];
      }

      /// Steal the contents of \a t.
      ///
      /// Close to move-semantics.
      void
      push (YY_MOVE_REF (T) t)
      {
        seq_.push_back (T ());
        operator[] (0).move (t);
      }

      /// Pop elements from the stack.
      void
      pop (std::ptrdiff_t n = 1) YY_NOEXCEPT
      {
        for (; 0 < n; --n)
          seq_.pop_back ();
      }

      /// Pop all elements from the stack.
      void
      clear () YY_NOEXCEPT
      {
        seq_.clear ();
      }

      /// Number of elements on the stack.
      index_type
      size () const YY_NOEXCEPT
      {
        return index_type (seq_.size ());
      }

      /// Iterator on top of the stack (going downwards).
      const_iterator
      begin () const YY_NOEXCEPT
      {
        return seq_.begin ();
      }

      /// Bottom of the stack.
      const_iterator
      end () const YY_NOEXCEPT
      {
        return seq_.end ();
      }

      /// Present a slice of the top of a stack.
      class slice
      {
      public:
        slice (const stack& stack, index_type range)
          : stack_ (stack)
          , range_ (range)
        {}

        const T&
        operator[] (index_type i) const
        {
          return stack_[range_ - i];
        }

      private:
        const stack& stack_;
        index_type range_;
      };

    private:
#if YY_CPLUSPLUS < 201103L
      /// Non copyable.
      stack (const stack&);
      /// Non copyable.
      stack& operator= (const stack&);
#endif
      /// The wrapped container.
      S seq_;
    };


    /// Stack type.
    typedef stack<stack_symbol_type> stack_type;

    /// The stack.
    stack_type yystack_;

    /// Push a new state on the stack.
    /// \param m    a debug message to display
    ///             if null, no trace is output.
    /// \param sym  the symbol
    /// \warning the contents of \a s.value is stolen.
    void yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym);

    /// Push a new look ahead token on the state on the stack.
    /// \param m    a debug message to display
    ///             if null, no trace is output.
    /// \param s    the state
    /// \param sym  the symbol (for its value and location).
    /// \warning the contents of \a sym.value is stolen.
    void yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym);

    /// Pop \a n symbols from the stack.
    void yypop_ (int n = 1);

    /// Constants.
    enum
    {
      yylast_ = 1844,     ///< Last index in yytable_.
      yynnts_ = 19,  ///< Number of nonterminal symbols.
      yyfinal_ = 14 ///< Termination state number.
    };


    // User arguments.
    shared_ptr<ModelAST> *result;

  };

  inline
  ModelParser::symbol_kind_type
  ModelParser::yytranslate_ (int t)
  {
    // YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to
    // TOKEN-NUM as returned by yylex.
    static
    const signed char
    translate_table[] =
    {
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82
    };
    // Last valid token kind.
    const int code_max = 337;

    if (t <= 0)
      return symbol_kind::S_YYEOF;
    else if (t <= code_max)
      return YY_CAST (symbol_kind_type, translate_table[t]);
    else
      return symbol_kind::S_YYUNDEF;
  }

  // basic_symbol.
  template <typename Base>
  ModelParser::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value ()
    , location (that.location)
  {
    switch (this->kind ())
    {
      case symbol_kind::S_qualifier: // qualifier
        value.copy< DeclQualifier > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_type: // type
        value.copy< Type > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FLOATL: // "float_literal"
        value.copy< float > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_INTL: // "int_literal"
        value.copy< int > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_decl: // decl
      case symbol_kind::S_decl_body: // decl_body
        value.copy< shared_ptr<Decl> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_dist: // dist
        value.copy< shared_ptr<Dist> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_guard: // guard
      case symbol_kind::S_exp: // exp
        value.copy< shared_ptr<Exp> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_location: // location
        value.copy< shared_ptr<Location> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_model: // model
        value.copy< shared_ptr<Model> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_module: // module
        value.copy< shared_ptr<ModuleAST> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_prop: // prop
        value.copy< shared_ptr<Prop> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_transition: // transition
        value.copy< shared_ptr<TransitionAST> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_effects: // effects
        value.copy< shared_vector<Effect> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_exp_seq: // exp_seq
        value.copy< shared_vector<Exp> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pbranches: // pbranches
        value.copy< shared_vector<PBranch> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_proplist: // proplist
        value.copy< shared_vector<Prop> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ID: // "id"
        value.copy< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_qualifierlist: // qualifierlist
        value.copy< vector<DeclQualifier> > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

  }



  template <typename Base>
  ModelParser::symbol_kind_type
  ModelParser::basic_symbol<Base>::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }

  template <typename Base>
  bool
  ModelParser::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return this->kind () == symbol_kind::S_YYEMPTY;
  }

  template <typename Base>
  void
  ModelParser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    switch (this->kind ())
    {
      case symbol_kind::S_qualifier: // qualifier
        value.move< DeclQualifier > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_type: // type
        value.move< Type > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_FLOATL: // "float_literal"
        value.move< float > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_INTL: // "int_literal"
        value.move< int > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_decl: // decl
      case symbol_kind::S_decl_body: // decl_body
        value.move< shared_ptr<Decl> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_dist: // dist
        value.move< shared_ptr<Dist> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_guard: // guard
      case symbol_kind::S_exp: // exp
        value.move< shared_ptr<Exp> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_location: // location
        value.move< shared_ptr<Location> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_model: // model
        value.move< shared_ptr<Model> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_module: // module
        value.move< shared_ptr<ModuleAST> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_prop: // prop
        value.move< shared_ptr<Prop> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_transition: // transition
        value.move< shared_ptr<TransitionAST> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_effects: // effects
        value.move< shared_vector<Effect> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_exp_seq: // exp_seq
        value.move< shared_vector<Exp> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_pbranches: // pbranches
        value.move< shared_vector<PBranch> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_proplist: // proplist
        value.move< shared_vector<Prop> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_ID: // "id"
        value.move< std::string > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_qualifierlist: // qualifierlist
        value.move< vector<DeclQualifier> > (YY_MOVE (s.value));
        break;

      default:
        break;
    }

    location = YY_MOVE (s.location);
  }

  // by_kind.
  inline
  ModelParser::by_kind::by_kind ()
    : kind_ (symbol_kind::S_YYEMPTY)
  {}

#if 201103L <= YY_CPLUSPLUS
  inline
  ModelParser::by_kind::by_kind (by_kind&& that)
    : kind_ (that.kind_)
  {
    that.clear ();
  }
#endif

  inline
  ModelParser::by_kind::by_kind (const by_kind& that)
    : kind_ (that.kind_)
  {}

  inline
  ModelParser::by_kind::by_kind (token_kind_type t)
    : kind_ (yytranslate_ (t))
  {}

  inline
  void
  ModelParser::by_kind::clear ()
  {
    kind_ = symbol_kind::S_YYEMPTY;
  }

  inline
  void
  ModelParser::by_kind::move (by_kind& that)
  {
    kind_ = that.kind_;
    that.clear ();
  }

  inline
  ModelParser::symbol_kind_type
  ModelParser::by_kind::kind () const YY_NOEXCEPT
  {
    return kind_;
  }

  inline
  ModelParser::symbol_kind_type
  ModelParser::by_kind::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }

#line 10 "/home/hobborg/FAMAF/Doctorado/fig/git/src/ModelParserGen.yy"
} // ModelParserGen
#line 3263 "/home/hobborg/FAMAF/Doctorado/fig/git/src/ModelParser.hpp"




#endif // !YY_YY_HOME_HOBBORG_FAMAF_DOCTORADO_FIG_GIT_SRC_MODELPARSER_HPP_INCLUDED
