#!/usr/bin/env sh
echo "---------[ Decompressing archive ]----------------------------";
unzip Modest-linux-x64.zip;
MODEST_LOCAL_DIR="$PWD/Modest";
type "$MODEST_LOCAL_DIR/modest" 2>&1 >/dev/null ||
	(echo "Decompressing the Modest Toolset failed; aborting" && exit 1);
echo "---------[ Done ]---------------------------------------------";
echo "---------[ Installing the Modest Toolset ]--------------------";
MODEST_SYS_DIR="/usr/local/bin/Modest";
sudo mkdir -p "$MODEST_SYS_DIR";
sudo cp -r "$MODEST_LOCAL_DIR"/* "$MODEST_SYS_DIR";
sudo chown -R `whoami`:`whoami` "$MODEST_SYS_DIR";
sudo ln -sf "$MODEST_SYS_DIR/modest" /usr/local/bin/modest;
echo "---------[ Done ]---------------------------------------------";
exit 0;
